Components.utils.import("resource://modules/kclobserver.jsm");
Components.utils.import("resource://gre/modules/ctypes.jsm");

function debugprint(str){
    var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
    getService(Components.interfaces.nsIConsoleService);
    aConsoleService.logStringMessage(str);
}

var StatsBarTimer;
var StatsBarTimer2;
var StatusBarMode;

var KclInsp = {

    init: function(){
        KclHttpObserver.init();
        KclHttpObserver.addCallback( KclInspCallback );
        StatusBarMode=0;
        StatusBarTimer= setInterval(function(){UpdateStatusBar();},1000);
        StatusBarTimer2= setInterval(function(){UpdateStatusBarMode();},5000);
    },

    destroy: function(){
        KclHttpObserver.removeCallback( KclInspCallback );
        KclHttpObserver.destroy();
        clearInterval(StatusBarTimer);
        clearInterval(StatusBarTimer2);
    }

}

const Cc = Components.classes;
const Ci = Components.interfaces;

const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const HTML_NS= "http://www.w3.org/1999/xhtml";

function KclInspCallback(request,str){
    var url = request.name;

    str = str.substring( str.indexOf('svdata=')+7 );
    var data = JSON.parse(str);

    if( url.match(/kcsapi\/api_get_master\/ship$/) ){
        KclInfo.gMasterShip = data.api_data;
        KclInfo.gMasterShipStr = str;

    }else if( url.match(/kcsapi\/api_get_member\/deck$/) ){
        KclInfo.gMemberFleet = data.api_data;
        UpdateFleetList();

    }else if( url.match(/kcsapi\/api_get_member\/ship2$/) ){
        KclInfo.gMemberShip = data.api_data;
        KclInfo.gMemberShipStr = str;
        KclInfo.gMemberFleet = data.api_data_deck;
        UpdateFleetList();
        initShipTree();
        UpdateBaseInfo();
        UpdateItemEquipList();
        UpdateItemList();
        initItemTree();

    }else if( url.match(/kcsapi\/api_get_member\/ship$/) ){
        KclInfo.gMemberShip = data.api_data;
        KclInfo.gMemberShipStr = str;

    }else if( url.match(/kcsapi\/api_get_member\/questlist$/) ){
        KclInfo.gQuestList = data.api_data.api_list;
        UpdateQuestList();

    }else if( url.match(/kcsapi\/api_get_member\/slotitem$/) ){
        KclInfo.gMemberItemList = data.api_data;
        KclInfo.gMemberItemStr = str;
        UpdateBaseInfo();
        UpdateItemList();
        initItemTree();

    }else if( url.match(/kcsapi\/api_get_member\/basic$/) ){
        KclInfo.gMemberBasic = data.api_data;
        UpdateBaseInfo();

    }else if( url.match(/kcsapi\/api_get_member\/ndock$/) ){
        KclInfo.gMemberNDock = data.api_data;

    }else if( url.match(/kcsapi\/api_get_member\/kdock$/) ){
        KclInfo.gMemberKDock = data.api_data;

    }else if( url.match(/kcsapi\/api_req_map\/start$/) ){
        KclInfo.gMapRequest = data.api_data;
        KclInfo.gMapRequest.Direction = "Start:"
        UpdateProgressLog();

    }else if( url.match(/kcsapi\/api_req_map\/next$/) ){
        KclInfo.gMapRequest = data.api_data;
        KclInfo.gMapRequest.Direction = "Next:"
        UpdateProgressLog();

    }else if( url.match(/kcsapi\/api_req_sortie\/battle$/) ){
        KclInfo.gBattle = data.api_data;
        KclInfo.gBattleStr = str;
        UpdateBattleLog();
        CalcBattleLog();

    }else if( url.match(/kcsapi\/api_req_sortie\/battleresult$/) ){
        KclInfo.gBattleResult = data.api_data;
        UpdateBattleResultLog();

    }
}

function UpdateBattleResultLog(){
    let bundle= document.getElementById("kclinsp-bundle");

    hw_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");
    let dispsortiebattleresult = hw_Branch.getBoolPref("dispsortiebattleresult");

    if(dispsortiebattleresult){
        let bundle= document.getElementById("kclinsp-bundle");
        let gmapID = GetDateTime() + bundle.getString("BATTLERESUT");
        let msg = KclInfo.gBattleResult.api_win_rank;
        if ( KclInfo.gBattleResult.api_get_flag[1] == 1 ){
            msg = msg + "(" + KclInfo.gBattleResult.api_get_ship.api_ship_name + ")";
        }
    UpdateSortieLog(gmapID + msg);
    }
}

function UpdateBattleLog(){
    let bundle= document.getElementById("kclinsp-bundle");

    hw_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");
    let dispsortieenemyset = hw_Branch.getBoolPref("dispsortieenemyset");

    if(dispsortieenemyset){
        let bundle= document.getElementById("kclinsp-bundle");
        let gmapID = GetDateTime() + bundle.getString("ENEMYSET") + JSON.stringify(KclInfo.gBattle.api_ship_ke);
        UpdateSortieLog(gmapID);
    }
}

function UpdateProgressLog(){
    let bundle= document.getElementById("kclinsp-bundle");
    let gEnemy = KclInfo.gMapRequest.api_enemy;
    let gHappen = KclInfo.gMapRequest.api_happening;
    let gItemGet = KclInfo.gMapRequest.api_itemget;
    let gmapID = GetDateTime() + KclInfo.gMapRequest.Direction 
               + KclInfo.gMapRequest.api_maparea_id + "-" 
               + KclInfo.gMapRequest.api_mapinfo_no + "-" 
               + KclInfo.gMapRequest.api_no + "("
               + KclInfo.gMapRequest.api_next + ")";
    let msg = "";
    if ( typeof gEnemy !== "undefined"){
        if ( KclInfo.gMapRequest.api_no == KclInfo.gMapRequest.api_bosscell_no) {
            msg = bundle.getString("ENEMYBOSS") + gEnemy.api_result_str + ":" + gEnemy.api_enemy_id;
        } else {
            msg = bundle.getString("ENEMY") + gEnemy.api_result_str + ":" + gEnemy.api_enemy_id;
        }
    }else if( typeof gHappen !== "undefined"){
        msg = bundle.getString("HAPPENING") + bundle.getString("MATERIAL" + gHappen.api_mst_id) + ":" + gHappen.api_count;
    }else if( typeof gItemGet !== "undefined"){
        msg = bundle.getString("ITEMGET") + bundle.getString("MATERIAL" + gItemGet.api_id) + ":" + gItemGet.api_getcount;
    }
    UpdateSortieLog(gmapID + msg);
}

function GetDateTime(){

    hw_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");
    let dispsortietime = hw_Branch.getBoolPref("dispsortietime");

    if(dispsortietime){
        let tDate= new Date();
        let tStr = tDate.getFullYear() + "/" + ("0" + (tDate.getMonth()+1)).slice(-2) + "/" + ( "0" + tDate.getDate()).slice(-2)
            tStr = ("0" + tDate.getHours()).slice(-2) + ":" + ("0" + tDate.getMinutes()).slice(-2) + ":" + ("0" + tDate.getSeconds()).slice(-2) + " ";
        return tStr;
    }else{
        return "";
    }
}

function UpdateSortieLog(str){
    if(document.getElementById("sortielog").value.length > 12000){
        document.getElementById("sortielog").value = document.getElementById("sortielog").value.slice(-8000);
    }
    if(document.getElementById("sortielog").value.length > 0){
        document.getElementById("sortielog").value =document.getElementById("sortielog").value + "\n" + str;
    }else{
        document.getElementById("sortielog").value = str;
    }
    document.getElementById("sortielog").inputField.scrollTop = document.getElementById("sortielog").inputField.scrollHeight
}

function UpdateBaseInfo(){
    document.getElementById("shipcountvalue").value = "[" + KclInfo.gMemberShip.length + "/" + KclInfo.gMemberBasic.api_max_chara + "]";
    document.getElementById("equipmentcountvalue").value = "[" + KclInfo.gMemberItemList.length + "/" + KclInfo.gMemberBasic.api_max_slotitem + "]";
}

function UpdateStatusBarMode(){
    let StBM = StatusBarMode;

    hw_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");
    let dispexped = hw_Branch.getBoolPref("dispexped");
    let dispndock = hw_Branch.getBoolPref("dispndock");
    let dispkdock = hw_Branch.getBoolPref("dispkdock");

    StBM++;
    StBM = StBM % 3;
    if(StBM == 0){
        if(dispexped){
        }else{
            if(dispndock){
                StBM=1;
            }else if(dispkdock){
                StBM=2;
            }else{
                StBM=3;
            }
        }
    }else if(StBM==1){
        if(dispndock){
        }else{
            if(dispkdock){
                StBM=2;
            }else if(dispexped){
                StBM=0;
            }else{
                StBM=3;
            }
        }
    }else if(StBM==2){
        if(dispkdock){
        }else{
            if(dispexped){
                StBM=0;
            }else if(dispndock){
                StBM=1;
            }else{
                StBM=3;
            }
        }
    }else{
        StBM=3;
    }
    StatusBarMode=StBM;
    clearInterval(StatusBarTimer2);
    StatusBarTimer2= setInterval(function(){UpdateStatusBarMode();},5000)
}

function UpdateStatusBar(){
    let bundle= document.getElementById("kclinsp-bundle");

    hw_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");
    let dispkdockdetail = hw_Branch.getBoolPref("dispkdockdetail");

    let dt = new Date();
    let kdockdetail = "";
    document.getElementById("fleetstatus").label = "-";
    document.getElementById("fleet1comm").label = "-";
    document.getElementById("fleet2comm").label = "-";
    document.getElementById("fleet3comm").label = "-";
    document.getElementById("fleet4comm").label = "-";
    if(StatusBarMode == 0){
        document.getElementById("fleetstatus").label = bundle.getString("EXPEDITION");
        for( let i in KclInfo.gMemberFleet ){
            let icnt = parseInt(i);
            if(KclInfo.gMemberFleet[icnt].api_mission[0] == 1){
                let remaintime = KclInfo.gMemberFleet[icnt].api_mission[2] - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60*60*1000));
                    let tMinute = ("0" + parseInt((remaintime % (60*60*1000))/(60*1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60*1000))   /   (1000))).slice(-2);
                    document.getElementById("fleet"+(icnt+1)+"comm").label = tHour + ":" + tMinute + ":" + tSecond;
                }else{
                    document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("RETURNED");
                }
            }else{
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("WAITING");
            }
        }
    }else if(StatusBarMode == 1 ){
        document.getElementById("fleetstatus").label = bundle.getString("NDOCK");
        for( let i in KclInfo.gMemberNDock ){
            let icnt = parseInt(i);
            if(KclInfo.gMemberNDock[icnt].api_state == 1){
                let remaintime = KclInfo.gMemberNDock[icnt].api_complete_time - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60*60*1000));
                    let tMinute = ("0" + parseInt((remaintime % (60*60*1000))/(60*1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60*1000))   /   (1000))).slice(-2);
                    document.getElementById("fleet"+(icnt+1)+"comm").label = tHour + ":" + tMinute + ":" + tSecond;
                }else{
                    document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("COMPLETED");
                }
            }else if(KclInfo.gMemberNDock[icnt].api_state == 0){
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("NOUSE");
            }else{
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("CLOSED");
            }
        }
    }else if(StatusBarMode == 2 ){
        document.getElementById("fleetstatus").label = bundle.getString("KDOCK");
        for( let i in KclInfo.gMemberKDock ){
            let icnt = parseInt(i);
            if(dispkdockdetail && (KclInfo.gMemberKDock[icnt].api_created_ship_id>0)){
                kdockdetail = " - " + SearchMasterShipByID(KclInfo.gMemberKDock[icnt].api_created_ship_id).api_name;
            }else{
                kdockdetail = "";
            }
            if(KclInfo.gMemberKDock[icnt].api_state == 2){
                let remaintime = KclInfo.gMemberKDock[icnt].api_complete_time - dt.getTime();
                if(remaintime > 0){
                    let tHour = parseInt(remaintime / (60*60*1000));
                    let tMinute = ("0" + parseInt((remaintime % (60*60*1000))/(60*1000))).slice(-2);
                    let tSecond = ("0" + parseInt((remaintime % (60*1000))   /   (1000))).slice(-2);
                    document.getElementById("fleet"+(icnt+1)+"comm").label = tHour + ":" + tMinute + ":" + tSecond + kdockdetail;
                }else{
                    document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("KCOMPLETED") + kdockdetail;
                }
            }else if(KclInfo.gMemberKDock[icnt].api_state == 0){
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("NOUSE");
            }else if(KclInfo.gMemberKDock[icnt].api_state == 3){
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("KCOMPLETED") + kdockdetail;
            }else{
                document.getElementById("fleet"+(icnt+1)+"comm").label = bundle.getString("CLOSED");
            }
        }

    }else{
    document.getElementById("fleetstatus").label = "-";
    document.getElementById("fleet1comm").label = "-";
    document.getElementById("fleet2comm").label = "-";
    document.getElementById("fleet3comm").label = "-";
    document.getElementById("fleet4comm").label = "-";
    };
}

function UpdateFleetList(){
    for( let i in KclInfo.gMemberFleet ){
        icnt = parseInt(i);
        for( let j in KclInfo.gMemberFleet[icnt].api_ship){
            jcnt = parseInt(j);
            let mShip = KclInfo.gMemberFleet[icnt].api_ship[jcnt];
            if(mShip > 0){
                let memShip = SearchMemberShip(mShip);
                let msShip = SearchMasterShip(mShip);
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"cond").value = memShip.api_cond;
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"name").value = msShip.api_name;

                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup1").value = "[" + memShip.api_kyouka[0] + "/" + (parseInt(msShip.api_houg[1]) - parseInt(msShip.api_houg[0])) + "]"
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup2").value = "[" + memShip.api_kyouka[1] + "/" + (parseInt(msShip.api_raig[1]) - parseInt(msShip.api_raig[0])) + "]"
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup3").value = "[" + memShip.api_kyouka[2] + "/" + (parseInt(msShip.api_tyku[1]) - parseInt(msShip.api_tyku[0])) + "]"
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup4").value = "[" + memShip.api_kyouka[3] + "/" + (parseInt(msShip.api_souk[1]) - parseInt(msShip.api_souk[0])) + "]"

            }else{
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"cond").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"name").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup1").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup2").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup3").value = ""
                document.getElementById("fleet"+(icnt+1)+"ship"+(jcnt+1)+"powup4").value = ""
            }
        }
    }

}

function UpdateQuestList(){
    for( let i in KclInfo.gQuestList ){
        icnt = parseInt(i);
        if ((KclInfo.gQuestList[icnt] instanceof Object)){
            document.getElementById("quest"+(icnt+1)+"name").value = KclInfo.gQuestList[icnt].api_title;
            if(KclInfo.gQuestList[icnt].api_now_count instanceof Array){
                document.getElementById("quest"+(icnt+1)+"score").value = "[" + KclInfo.gQuestList[icnt].api_now_count.join() + "]";
                document.getElementById("quest"+(icnt+1)+"require").value = "[" + KclInfo.gQuestList[icnt].api_clear_count.join() + "]";
            }else{
                document.getElementById("quest"+(icnt+1)+"score").value = "[" + KclInfo.gQuestList[icnt].api_now_count + "]";
                document.getElementById("quest"+(icnt+1)+"require").value = "[" + KclInfo.gQuestList[icnt].api_clear_count + "]";
            }
        }else{
            document.getElementById("quest"+(icnt+1)+"name").value = "";
            document.getElementById("quest"+(icnt+1)+"score").value = "";
            document.getElementById("quest"+(icnt+1)+"require").value = "";
        }
    }

}


function SearchMemberShip( member_ship_id ){
    try{
        for( let cnt in KclInfo.gMemberShip ){
            let ship = KclInfo.gMemberShip[cnt];
            let id = ship.api_id;
            if( id==member_ship_id ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function SearchMasterShip( member_ship_id ){
    let shipid;
    try{
        for( let cnt in KclInfo.gMemberShip ){
            let ship = KclInfo.gMemberShip[cnt];
            let id = ship.api_id;
            shipid = ship.api_ship_id;
            if( id == member_ship_id ) break;
        }
        for( let cnt in KclInfo.gMasterShip ){
            let ship = KclInfo.gMasterShip[cnt];
            if( ship.api_id == shipid ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function SearchMasterShipByID( master_ship_id ){
    try{
        for( let cnt in KclInfo.gMasterShip ){
            let ship = KclInfo.gMasterShip[cnt];
            if( ship.api_id==master_ship_id ){
                return ship;
            }
        }
    } catch (err) {
    }
    return "";
}

function CopyToClipboard(str){
    if(str.length<=0) return;
    let gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].  
    getService(Components.interfaces.nsIClipboardHelper);  
    gClipboardHelper.copyString(str);
}

var gShipTreeView = null;
var gShipTreeList = [];

function initShipTree(){
    gShipTreeList = [];
    for (let i in KclInfo.gMemberShip){
        msShip=SearchMasterShip(KclInfo.gMemberShip[i].api_id);
        let nAry = [
            KclInfo.gMemberShip[i].api_id,
            msShip.api_name,
            msShip.api_stype,
            KclInfo.gMemberShip[i].api_lv,
            KclInfo.gMemberShip[i].api_cond,
            msShip.api_houg[1]-msShip.api_houg[0]-KclInfo.gMemberShip[i].api_kyouka[0],
            msShip.api_raig[1]-msShip.api_raig[0]-KclInfo.gMemberShip[i].api_kyouka[1],
            msShip.api_tyku[1]-msShip.api_tyku[0]-KclInfo.gMemberShip[i].api_kyouka[2],
            msShip.api_souk[1]-msShip.api_souk[0]-KclInfo.gMemberShip[i].api_kyouka[3],
            i]
        gShipTreeList.push(nAry);
    }
    gShipTreeView = new ShipTreeView(KclInfo.gMemberShip);
    for (let i in document.getElementById("ShipTree").columns){
        document.getElementById("ShipTree").columns.getColumnAt(i).element.setAttribute("sortDirection","natural");
    }
    document.getElementById("ShipTree").view = gShipTreeView;
}

function destroyShipTree(){
    document.getElementById("ShipTree").view = null;
}

function ShipTreeView(aData) {
    this._data = aData;
}

ShipTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount() {
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties) {},
    getCellProperties: function(row, col, properties) {},
    getColumnProperties: function(col, properties) {},
    isContainer: function(index) { return false; },
    isContainerOpen: function(index) { return false; },
    isContainerEmpty: function(index) { return false; },
    isSeparator: function(index) {
        return this._data[index] == null;
    },
    isSorted: function() { return false; },
    canDrop: function(targetIndex, orientation, dataTransfer) { return false; },
    drop: function(targetIndex, orientation, dataTransfer) {},
    getParentIndex: function(rowIndex) { return -1; },
    hasNextSibling: function(rowIndex, afterIndex) { return false; },
    getLevel: function(index) { return 0; },
    getImageSrc: function(row, col) {},
    getProgressMode: function(row, col) {},
    getCellValue: function(row, col) {},
    getCellText: function(row, col) {
        let msShip = SearchMasterShip(this._data[gShipTreeList[row][9]].api_id);
        let memShip = SearchMemberShip(this._data[gShipTreeList[row][9]].api_id);
        switch (col.id) {
            case "api_id" : return parseInt(memShip.api_id);
            case "api_name" : return msShip.api_name;
            case "api_stype" : return msShip.api_stype;
            case "api_lv" : return parseInt(memShip.api_lv);
            case "api_cond" : return parseInt(memShip.api_cond);
            case "api_kyouka1" : return (parseInt(msShip.api_houg[1]) - parseInt(msShip.api_houg[0])) - parseInt(memShip.api_kyouka[0]);
            case "api_kyouka2" : return (parseInt(msShip.api_raig[1]) - parseInt(msShip.api_raig[0])) - parseInt(memShip.api_kyouka[1]);
            case "api_kyouka3" : return (parseInt(msShip.api_tyku[1]) - parseInt(msShip.api_tyku[0])) - parseInt(memShip.api_kyouka[2]);
            case "api_kyouka4" : return (parseInt(msShip.api_souk[1]) - parseInt(msShip.api_souk[0])) - parseInt(memShip.api_kyouka[3]);
            default : return 0;
        }
    },
    setTree: function(tree) {
        if (tree) {
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index) {},
    cycleHeader: function(col) {
        let sOrder=col.element.getAttribute("sortDirection");
        for (let i in col.columns){
            col.columns.getColumnAt(i).element.setAttribute("sortDirection","natural");
        };
        let odr = 0;
        if ( sOrder == "ascending" ) {
            odr = -1;
            sOrder = "descending" ;
        } else {
            odr = 1;
            sOrder = "ascending"  ;
        };
        gShipTreeList.sort(
            function(a,b){
                return (a[col.index]-b[col.index])*odr;
            }
        );
        col.element.setAttribute("sortDirection",sOrder);
        this._treeBoxObject.invalidate();
    },
    selectionChanged: function() {},
    cycleCell: function(row, col) {
    },
    isEditable: function(row, col) { return false; },
    isSelectable: function(row, col) {},
    setCellValue: function(row, col, value) {},
    setCellText: function(row, col, value) {},
    performAction: function(action) {},
    performActionOnRow: function(action, row) {},
    performActionOnCell: function(action, row, col) {},
};

var gItemEquipList = [];
var gItemList = [];

function UpdateItemEquipList(){
    gItemEquipList = [];
    for ( let i in KclInfo.gMemberShip){
        if ( KclInfo.gMemberShip[i].api_slot[0] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[0])]="1";
        }
        if ( KclInfo.gMemberShip[i].api_slot[1] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[1])]="1";
        }
        if ( KclInfo.gMemberShip[i].api_slot[2] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[2])]="1";
        }
        if ( KclInfo.gMemberShip[i].api_slot[3] > 0){
            gItemEquipList[parseInt(KclInfo.gMemberShip[i].api_slot[3])]="1";
        }
    }
}

function UpdateItemList(){
    gItemList=[];
    for ( let i in KclInfo.gMemberItemList){
        let ItemID = KclInfo.gMemberItemList[i].api_name;
        let ItemEquipID=gItemEquipList[parseInt(KclInfo.gMemberItemList[i].api_id)];
        if ( typeof ItemEquipID === "undefined"){
            ItemEquipID = 0;
        }
        let ItemListID = gItemList[ItemID];
        if ( typeof ItemListID === "undefined"){
            gItemList[ItemID] = [KclInfo.gMemberItemList[i].api_slotitem_id,ItemID,0,0];
        }
        gItemList[ItemID][3] = gItemList[ItemID][3] + 1;
        gItemList[ItemID][2] = parseInt(gItemList[ItemID][2]) + parseInt(ItemEquipID);
    }
    let reList=[];
    for (let j in gItemList){
       let nAry = [
           gItemList[j][0],
           gItemList[j][1],
           gItemList[j][2],
           gItemList[j][3]
           ]
       reList.push(nAry);
    }
    gItemList = [];
    gItemList = reList;
}

var gItemTreeView = null;

function initItemTree(){
    gItemTreeView = new ItemTreeView(gItemList);
    for (let i in document.getElementById("ItemTree").columns){
        document.getElementById("ItemTree").columns.getColumnAt(i).element.setAttribute("sortDirection","natural");
    }
    document.getElementById("ItemTree").view = gItemTreeView;
}

function destroyItemTree(){
    document.getElementById("ItemTree").view = null;
}

function ItemTreeView(aData) {
    this._data = aData;
}

ItemTreeView.prototype = {
    _treeBoxObject: null,
    get rowCount() {
        return this._data.length;
    },
    selection: null,
    getRowProperties: function(index, properties) {},
    getCellProperties: function(row, col, properties) {},
    getColumnProperties: function(col, properties) {},
    isContainer: function(index) { return false; },
    isContainerOpen: function(index) { return false; },
    isContainerEmpty: function(index) { return false; },
    isSeparator: function(index) {
        return this._data[index] == null;
    },
    isSorted: function() { return false; },
    canDrop: function(targetIndex, orientation, dataTransfer) { return false; },
    drop: function(targetIndex, orientation, dataTransfer) {},
    getParentIndex: function(rowIndex) { return -1; },
    hasNextSibling: function(rowIndex, afterIndex) { return false; },
    getLevel: function(index) { return 0; },
    getImageSrc: function(row, col) {},
    getProgressMode: function(row, col) {},
    getCellValue: function(row, col) {},
    getCellText: function(row, col) {
        switch (col.index) {
            case 0 : return gItemList[row][0];
            case 1 : return gItemList[row][1];
            case 2 : return gItemList[row][2];
            case 3 : return gItemList[row][3];
            default : return 0;
        }
    },
    setTree: function(tree) {
        if (tree) {
            this._treeBoxObject = tree;
        }
        else {
            this._treeBoxObject = null;
            this._data = null;
        }
    },
    toggleOpenState: function(index) {},
    cycleHeader: function(col) {
        let sOrder=col.element.getAttribute("sortDirection");
        for (let i in col.columns){
            col.columns.getColumnAt(i).element.setAttribute("sortDirection","natural");
        };
        let odr = 0;
        if ( sOrder == "ascending" ) {
            odr = -1;
            sOrder = "descending" ;
        } else {
            odr = 1;
            sOrder = "ascending"  ;
        };
        gItemList.sort(
            function(a,b){
                return (a[col.index]-b[col.index])*odr;
            }
        );
        col.element.setAttribute("sortDirection",sOrder);
        this._treeBoxObject.invalidate();
    },
    selectionChanged: function() {},
    cycleCell: function(row, col) {
    },
    isEditable: function(row, col) { return false; },
    isSelectable: function(row, col) {},
    setCellValue: function(row, col, value) {},
    setCellText: function(row, col, value) {},
    performAction: function(action) {},
    performActionOnRow: function(action, row) {},
    performActionOnCell: function(action, row, col) {},
};

function DeleteSortieLog(){
    document.getElementById("sortielog").value ="";
}

function CalcBattleLog(){

    hw_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");
    let dispsortiecalcbattle = hw_Branch.getBoolPref("dispsortiecalcbattle");
    if (dispsortiecalcbattle == false){
        return "";
    }

//initialize
    let nowhps = KclInfo.gBattle.api_nowhps;
    let maxhps = KclInfo.gBattle.api_maxhps;
    let dmghps = [0, 0,0,0,0,0,0 ,0,0,0,0,0,0];

//api_stage_flag
    if(KclInfo.gBattle.api_stage_flag[2] == 1){
        let fdam = KclInfo.gBattle.api_kouku.api_stage3.api_fdam;
        for(let i in fdam){
            let icnt = parseInt(i);
            if(fdam[icnt] != -1){
                dmghps[icnt] = dmghps[icnt] + parseFloat(fdam[icnt]);
            }
        }
        let edam = KclInfo.gBattle.api_kouku.api_stage3.api_edam;
        for(let i in edam){
            let icnt = parseInt(i);
            if(edam[icnt] != -1){
                dmghps[icnt+6] = dmghps[icnt+6] + parseFloat(edam[icnt]);
            }
        }

debugprint("stage3:"+ dmghps.join(","));
    }


//api_support_flag
    if(KclInfo.gBattle.api_support_flag == 1){
debugprint("support:"+ dmghps.join(","));
    }

//api_opening_flag
    if(KclInfo.gBattle.api_opening_flag == 1){
        let fdam = KclInfo.gBattle.api_opening_atack.api_fdam;
        for(let i in fdam){
            let icnt = parseInt(i);
            if(fdam[icnt] != -1){
                dmghps[icnt] = dmghps[icnt] + parseFloat(fdam[icnt]);
            }
        }
        let edam = KclInfo.gBattle.api_opening_atack.api_edam;
        for(let i in edam){
            let icnt = parseInt(i);
            if(edam[icnt] != -1){
                dmghps[icnt+6] = dmghps[icnt+6] + parseFloat(edam[icnt]);
            }
        }
debugprint("opening:"+ dmghps.join(","));
    }
//api_hourai_flag[0]
    if(KclInfo.gBattle.api_hourai_flag[0] == 1){
        let houg = KclInfo.gBattle.api_hougeki1;
        for (let i in houg.api_df_list){
            let icnt = parseInt(i);
            let j=parseInt(houg.api_df_list[icnt]);
            if(houg.api_damage[icnt] != -1){
                dmghps[j]=dmghps[j] + parseFloat(houg.api_damage[icnt]);
            }
        }
debugprint("hougeki1:"+ dmghps.join(","));
    }
//api_hourai_flag[1]
    if(KclInfo.gBattle.api_hourai_flag[1] == 1){
        let houg = KclInfo.gBattle.api_hougeki2;
        for (let i in houg.api_df_list){
            let icnt = parseInt(i);
            let j=parseInt(houg.api_df_list[icnt]);
            if(houg.api_damage[icnt] != -1){
                dmghps[j]=dmghps[j] + parseFloat(houg.api_damage[icnt]);
            }
        }
debugprint("hougeki2:"+ dmghps.join(","));
    }
//api_hourai_flag[3]
    if(KclInfo.gBattle.api_hourai_flag[3] == 1){
        let fdam = KclInfo.gBattle.api_raigeki.api_fdam;
        for(let i in fdam){
            let icnt = parseInt(i);
            if(fdam[icnt] != -1){
                dmghps[icnt] = dmghps[icnt] + parseFloat(fdam[icnt]);
            }
        }
        let edam = KclInfo.gBattle.api_raigeki.api_edam;
        for(let i in edam){
            let icnt = parseInt(i);
            if(edam[icnt] != -1){
                dmghps[icnt+6] = dmghps[icnt+6] + parseFloat(edam[icnt]);
            }
        }
debugprint("raigeki:"+ dmghps.join(","));
    }
//calculate
    for (let i=0; i<13; i++){
        dmghps[i]= nowhps[i]-dmghps[i];
        if (dmghps[i]<0){dmghps[i]=0}
    }

    let bundle= document.getElementById("kclinsp-bundle");
    let fMsg = bundle.getString("MYFLEET");
    let eMsg = bundle.getString("ENEMYFLEET");
    for (let i=1; i<7; i++){
        if(maxhps[i] != -1){
            fMsg=fMsg + "[" + dmghps[i] + "/" + maxhps[i] + "]";
        }
    }
    for (let i=7; i<13; i++){
        if(maxhps[i] != -1){
            eMsg=eMsg + "[" + dmghps[i] + "/" + maxhps[i] + "]";
        }
    }
// output
    UpdateSortieLog(GetDateTime() + fMsg);
    UpdateSortieLog(GetDateTime() + eMsg);

}

window.addEventListener("load", function(e){ KclInsp.init(); }, false);
window.addEventListener("unload", function(e){ KclInsp.destroy(); }, false);
