/* -*- mode: js2;-*- */

var EXPORTED_SYMBOLS = ["KclHttpObserver","KclInfo"];


var KclInfo = {
    gMasterShip: [],
    gMemberShip: [],
    gMemberFleet: [],
    gQuestList: [],
    gMasterShipStr: [],
    gMemberShipStr: [],
    gMemberBasic: [],
    gMemberItemList: [],
    gMemberItemStr: [],
    gMemberNDock: [],
    gMemberKDock: [],
    gMapRequest: [],
    gBattle: [],
    gBattleStr: [],
    gBattleResult: []
};

const Cc = Components.classes;
const Ci = Components.interfaces;

function debugprint(str){
    var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].
	getService(Components.interfaces.nsIConsoleService);
    aConsoleService.logStringMessage(str);
}

function CCIN(cName, ifaceName) {
    return Cc[cName].createInstance(Ci[ifaceName]);
}

var callback = new Array();

function TracingListener() {
    this.originalListener = null;
}

TracingListener.prototype =
{
    onDataAvailable: function(request, context, inputStream, offset, count) {
        var binaryInputStream = CCIN("@mozilla.org/binaryinputstream;1","nsIBinaryInputStream");
        var storageStream = CCIN("@mozilla.org/storagestream;1", "nsIStorageStream");
        var binaryOutputStream = CCIN("@mozilla.org/binaryoutputstream;1","nsIBinaryOutputStream");

        binaryInputStream.setInputStream(inputStream);
        storageStream.init(8192, count, null);
        binaryOutputStream.setOutputStream(storageStream.getOutputStream(0));

        var data = binaryInputStream.readBytes(count);
        this.receivedData.push(data);
        binaryOutputStream.writeBytes(data, count);

        this.originalListener.onDataAvailable(request, context,storageStream.newInputStream(0), offset, count);
    },

    onStartRequest: function(request, context) {
        this.originalListener.onStartRequest(request, context);
        this.receivedData = new Array();
    },

    onStopRequest: function(request, context, statusCode) {
        this.originalListener.onStopRequest(request, context, statusCode);

        var s = this.receivedData.join('');
        for( var k in  callback ){
            var f = callback[k];
            if( typeof f=='function' ){
            f( request, s );
            }
        }
    },

    QueryInterface: function (aIID) {
        if (aIID.equals(Ci.nsIStreamListener) ||
            aIID.equals(Ci.nsISupports)) {
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    }
};

var KclHttpObserver =
{
    HookCounter: 0,

    observe: function(aSubject, aTopic, aData){
        if (aTopic == "http-on-examine-response"){
            var httpChannel = aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
            if( httpChannel.URI.spec.match(/^http.*\/kcsapi\//) ){
                var newListener = new TracingListener();
                aSubject.QueryInterface(Ci.nsITraceableChannel);
                newListener.originalListener = aSubject.setNewListener(newListener);
            }
        }
    },

    QueryInterface : function (aIID) {
        if (aIID.equals(Ci.nsIObserver) || aIID.equals(Ci.nsISupports)){
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    },

    addCallback: function(fname){
        callback.push( fname );
        debugprint( 'start kclinsp/add callback='+callback.length );
    },

    removeCallback: function( fname ){
        for( var kptr in callback ){
            if( callback[kptr]==fname ){
                callback.splice(kptr,1);
                debugprint( 'stop kclinsp/remove callback='+callback.length );
            }
        }
    },

    init: function(){
        if( this.HookCounter==0 ){
            this.observerService = Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService);
            this.observerService.addObserver(this, "http-on-examine-response", false);
        }
        this.HookCounter++;
    },

    destroy: function(){
        this.HookCounter--;
        if( this.HookCounter<=0 ){
            this.observerService.removeObserver(this, "http-on-examine-response");
            this.HookCounter = 0;
        }
    }

};
